// Generated by CoffeeScript 1.6.3
var properties, wrapper;

wrapper = {
  attach: function(server) {
    var app, websocket;
    if (require('connect')().toString() === server.toString()) {
      app = server;
      app.stack.splice(2, 0, {
        route: '',
        handle: require('./middleware')({
          patch: true
        })
      });
      server = require('http').createServer(app);
      require('./websocket')(server);
      return server;
    }
    app = server.listeners('request')[0];
    if (typeof app === 'function') {
      server.removeListener('request', app);
    }
    server.on('request', require('./middleware')(app));
    websocket = require('./websocket')(server);
    return {
      app: app,
      server: server,
      websocketServer: websocket.server,
      close: websocket.close,
      send: websocket.send,
      listen: function() {
        return server.listen.apply(server, arguments);
      }
    };
  },
  reload: function(server, dir) {
    var bebop;
    if (dir == null) {
      dir = process.cwd();
    }
    bebop = this.attach(server);
    if (dir) {
      require('./watch')(dir, function(filename) {
        return bebop.send({
          type: 'reload',
          filename: filename
        });
      });
    }
    return server;
  }
};

properties = {};

['client', 'compilers', 'middleware', 'server', 'watch', 'websocket'].forEach(function(property) {
  return properties[property] = {
    enumerable: true,
    get: function() {
      return require('./' + property);
    }
  };
});

Object.defineProperties(wrapper, properties);

module.exports = wrapper;

/*
//@ sourceMappingURL=index.map
*/
