// Generated by CoffeeScript 1.6.3
var bebopInclude, fs, injectJs, serveStatic;

fs = require('fs');

bebopInclude = '<script src="/bebop-client/bebop.js"></script>\n';

injectJs = function(res) {
  var appendScript, end, setHeader;
  appendScript = false;
  end = res.end;
  setHeader = res.setHeader;
  res.setHeader = function(name, value) {
    if (/text\/html/i.test(value)) {
      appendScript = true;
    } else if (name === 'Content-Length' && appendScript) {
      value = parseInt(value, 10) + bebopInclude.length;
    }
    return setHeader.call(res, name, value);
  };
  return res.end = function(chunk, encoding) {
    if (appendScript) {
      res.write(bebopInclude, encoding);
    }
    return end.call(res, chunk, encoding);
  };
};

serveStatic = function(req, res) {
  var headers;
  switch (req.url) {
    case '/bebop-client/bebop.js':
      headers = {
        'Content-Type': 'application/javascript',
        'SourceMap': 'bebop.map',
        'X-SourceMap': 'bebop.map'
      };
      break;
    case '/bebop-client/bebop.map':
      headers = {
        'Content-Type': 'application/json'
      };
      break;
    case '/bebop-client/bebop.coffee':
      headers = {
        'Content-Type': 'application/coffeescript'
      };
  }
  res.writeHead(200, headers);
  return fs.createReadStream(__dirname + '/..' + req.url).pipe(res);
};

module.exports = function(options) {
  var app, middleware;
  if (typeof options === 'function') {
    options = {
      app: options
    };
  } else {
    if (options == null) {
      options = {};
    }
  }
  app = options.app;
  middleware = function(req, res, next) {
    if (/^\/bebop-client/.test(req.url)) {
      return serveStatic(req, res);
    }
    injectJs(res);
    if (typeof app === 'function') {
      app(req, res);
    }
    if (typeof next === 'function') {
      return next();
    }
  };
  return function bebop(req, res, next) { return middleware(req, res, next); };;
};

/*
//@ sourceMappingURL=middleware.map
*/
